<?php
// XI Core Ajax Helper Functions
//
// Copyright (c) 2008-2009 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: ajaxhelpers-misc.inc.php 13 2009-11-14 21:12:29Z egalstad $

include_once(dirname(__FILE__).'/../componenthelper.inc.php');
	

////////////////////////////////////////////////////////////////////////
// MISC AJAX FUNCTIONS
////////////////////////////////////////////////////////////////////////
	
function xicore_ajax_get_xi_news_feed_html($args=null){
	global $lstr;
	
	$output='';

	$output.='
	<table class="infotable">
	<thead>
	<tr><th>&nbsp;</th></tr>
	</thead>
	<tbody>
	';
	
	$output.="<tr><td>";
	$output.="<ul>";
	
	// where do we get news from
	$url="http://www.nagios.com/backend/feeds/products/nagiosxi/";
	
	$update_news=false;
	$news=array();
	$newsraw=get_meta(METATYPE_NONE,0,"xinews");
	if($newsraw==null || have_value($newsraw)==false)
		$update_news=true;
	else{
	
		$news=unserialize($newsraw);
		
		// is it time to update the news? */
		$now=time();
		if(($now-intval($news["time"])) > 60*60*24)
			$update_news=true;
			
		//print_r($news);
		}
		
	$update_news=true;
	
	// fetch new news
	if($update_news==true){
	
		// fetch news
		$rss=simplexml_load_file($url);
		//$rss=new SimpleXMLElement($url,LIBXML_NOCDATA,true);
		//print_r($rss);
		
		$newsitems=array();
		foreach($rss->channel->item as $i){
			$newsitems[]=array(
				"link" => strval($i->link),
				"title" => strval($i->title),
				"description" => strval($i->description),		
				);
			}
		
		// cache news
		$news["time"]=time();
		//$news["rss"]=json_encode($rss);
		$news["rss"]=json_encode($newsitems);
		//print_r($news);
		set_meta(METATYPE_NONE,0,"xinews",serialize($news));
		$newsitems_s=json_decode($news["rss"]);
		$newsitems=(array)$newsitems_s;
		}
		
	// use cached news
	else{
		//print_r($newsraw);
		$news=unserialize($newsraw);
		$newsitems_s=json_decode($news["rss"]);
		$newsitems=(array)$newsitems_s;
		}
	
	
	
	$x=0;
	//print_r($newsitems);
	foreach($newsitems as $is){
		$x++;
		if($x>3)
			break;
		$i=(array)$is;
		$link=strval($i["link"]);
		$title=strval($i["title"]);
		$description=strval($i["description"]);
		$output.="<li><a href='".$link."' target='_blank'>".$title."</a><br>".$description."</li>";
		}

		
	$output.="</ul>";
	$output.="</td></tr>";
		
	$output.='
	</tbody>
	</table>
	';
			
	return $output;
	}
	
	
	
	
?>